<?php

  include("html_functions.php");



  ################## PAGE INITIALIZATION #########################

  $lgid=$_SESSION['lgid'];

  $lgpath=$_SESSION['lgpath'];

  $date=new DateTime($_SESSION['lgdate']);

  $lgyear=$_SESSION['lgyear'];



  $team_no = $_POST['team'];

  $debug=(isset($_POST['debug'])?$_POST['debug']:"");



  # Title Bar

  $title='Team Trade Block Admin - Forum Updater';



  page_head($title,$_SESSION['lgpath'],"","","./text_functions.js");

  echo " <div id='topbar'>\n";

  main_titlebar($lgid,$_SESSION['lgpath'],$title,$team_no);

  nav_toolbar('front_office',"Front Office");

  echo " </div>   <!-- END topbar DIV -->\n";

  echo " <div id='contentpane'>\n";



  //StatsLabPath
  include($_SESSION['adminpath']."/dbopen.php");
  $query="SELECT setting,value FROM ootp_sql_admin WHERE module='admin' AND (setting IN ('StatsLabPath','serverurl','HTMLPath') OR setting LIKE '%slack%' OR setting LIKE '%discord%')";
  $result=mysqli_query($db,$query);
  if (mysqli_num_rows($result))
  {
	  while ($row=mysqli_fetch_array($result))
	  {
		  $field=$row['setting'];
		  $val=$row['value'];

		  switch ($field)
		  {
              case 'StatsLabPath' : $_SESSION['StatsLabPath']=$val; break;
              case 'ServerURL': $_SESSION['serverurl']=$val;break;
              case 'HTMLPath' : $_SESSION['HTMLPath']=$val; break;
              default:
                $settings[$field]=$val;
		  }

		  $StatsLabPath=$_SESSION['StatsLabPath'];

          if (strtolower(substr($_SESSION['StatsLabPath'],0,4))!="http") {$StatsLabPath=$_SESSION['serverurl'].$_SESSION['StatsLabPath'];}
          $HTMLPath=$_SESSION['serverurl'].$_SESSION['HTMLPath'];
	  }
  }

  //Get Team info
  $query="SELECT team_id,league_id,name,nickname,abbr,parent_team_id,league_id,level,background_color_id,text_color_id,logo_file_name FROM teams WHERE (team_id=".$team_no." OR parent_team_id=".$team_no.");";
    $result=mysqli_query($db,$query);
    if (mysqli_num_rows($result))
    {
        while ($row=mysqli_fetch_array($result))
        {
            $tid=$row['team_id'];
            $league_id=$row['league_id'];
            
            $teams[$tid]['name']=$row['name']." ".$row['nickname'];
            $teams[$tid]['city']=$row['name'];
            $teams[$tid]['abbr']=$row['abbr'];
            $teams[$tid]['nickname']=$row['nickname'];
            $teams[$tid]['logo_file_name']=$row['logo_file_name'];
            $teams[$tid]['league_id']=$row['league_id'];
            
            $lvl=get_level($row['level']);

            $teams[$tid]['level']=$lvl;
            $teams[$tid]['background_color_id']=$row['background_color_id'];
            $teams[$tid]['text_color_id']=$row['text_color_id'];
            $teams[$tid]['logo_file_name']=urlencode($row['logo_file_name']);

            if (!isset($leagues[$league_id]['lvl'])) {$leagues[$league_id]['lvl']=$lvl;}
        }
    }

$debug_string = '';

$timestamp = time();

$error_count = 0;


##
## Display Message:
##
$debug_string .= "   <h2>Under Construction!! <br /><span style='color:red;'>IL RULES!!!</span></h2>\n";
$debug_string .= "   <h3>Time stamp: $timestamp</h3\n";
$debug_string .= "   <p>Team ID No: $team_no </p>\n";

	## Post to Slack
	if ($settings['slackEnable']==1)
	{
		$serviceURL = $settings['slackServiceURL'];
        
		$msg = "The ".$teams[$team_no]['name']." have updated their <$StatsLabPath/tradeBlock.php?team_id=$team_no|trade block>";

		if (isset($settings['slackTradeChannel'])&&($settings['slackTradeChannel']!="")) {$channel=$settings['slackTradeChannel'];}
		else {$channel=$settings['slackDefChannel'];}

		$dataArray = Array (
			"channel"    => $channel,
			"username"   => $settings['slackUser'],
			"icon_emoji" => $settings['slackIcon'],
			"text"       => $msg
		);

        $data = "payload=" . json_encode($dataArray);

        if (($debug!=1)&&($_GET['showq']!=1))
		{
			$ch = curl_init($serviceURL);

			curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
			curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

            curl_exec($ch);

			$retcode = curl_getinfo($ch, CURLINFO_HTTP_CODE); // $retcode > 400 -> not found, $retcode = 200, found.

			if ($retcode==200)
            {
                1;
                // header('Location: '.$_SERVER['HTTP_REFERER']);
            }
			else
			{
                echo "Slack return code: $retcode</br>";
				echo curl_error($ch);
				echo "<br>\n";
				echo $data;
			}

			curl_close($ch);
		}
		else
		{
			echo "<b>Slack Test:</b><br/>\n";
			echo "Service URL: $serviceURL<br/>\n";
			echo "<br/>\n";
			echo $data;
			echo "<br/>\n";
			echo "<br/>\n";
		}
	}

    ## Post to Discord
    if ($settings['discordEnable']==1)
    {
        if (isset($settings['discordTradeURL'])&&($settings['discordTradeURL']!="")) {$serviceURL=$settings['discordTradeURL'];}
        else {$serviceURL=$settings['discordPrimaryURL'];}

        $msg="";
        $msg .= "The [".$teams[$team_no]['name']."](".$HTMLPath."/teams/team_".$team_no.".html) have updated their trade block";

        if (isset($settings['slackTradeChannel'])&&($settings['slackTradeChannel']!="")) {$channel=$settings['slackTradeChannel'];}
        else {$channel=$settings['slackDefChannel'];}

        $dcTimestamp = date("c", strtotime("now"));
        
        ## Get Trade Block Needs
        $needs_text="";
        $needsArray=Array("c","fb","sb","tb","ss","lf","cf","rf","sp","rp");
        $nCnt=0;
        foreach ($needsArray as $key => $val)
        {
            if (isset($_POST[$val])&&($_POST[$val]==1)) {
                $nCnt++;
                if ($nCnt>1) {$needs_text.=", ";}
                switch ($val) {
                    case 'fb': $needs_text.="1B"; break;
                    case 'sb': $needs_text.="2B"; break;
                    case 'tb': $needs_text.="3B"; break;
                    default:
                        $needs_text.=strtoupper($val);
                        break;
                }
            }
        }
        
        ## Get Notable Players
        $query="SELECT p.player_id,first_name,last_name,team_id,position,role,age,injury_is_injured,pv.sortVal FROM players as p,(";
        $query.="SELECT player_id,overall_value,ratings_value,talent_value,IF(talent_value>ratings_value,talent_value,ratings_value) as sortVal FROM players_value WHERE player_id IN (";
        $query.="SELECT player_id FROM players_roster_status WHERE team_id IN (";
        $query.="SELECT team_id FROM teams WHERE (team_id=$team_no OR parent_team_id=$team_no)";
        $query.=") AND trade_status=2";
        $query.=")";
        $query.=") as pv";
        $query.=" WHERE p.player_id=pv.player_id ORDER BY sortVal DESC;";
        $result=mysqli_query($db,$query);
        $pCnt=0;
        $notableText="";
        if (mysqli_num_rows($result))
        {
            while ($row=mysqli_fetch_array($result))
            {
                $pid=$row['player_id'];
                $pCnt++;
                if ($pCnt>3) {continue;}
                
                $name=$row['first_name']." ".$row['last_name'];
                $pos=$row['position'];
                $role=$row['role'];
                if ($pos==1) {$pos=$role;}
                
                $pos=get_pos($pos,1);

                $tid=$row['team_id'];
                $age=$row['age'];
                $inj=$row['injury_is_injured'];

                if ($pCnt>1) {$notableText.="\n";}
                $notableText.="$pos ";
                $notableText.="[$name]($StatsLabPath/player.php?player_id=$pid&league_id=".$teams[$tid]['league_id'].")";
                $notableText.=" ([".$teams[$tid]['level']."]($lgpath/teams/team_$tid.html))";
                $notableText.=" - $age yrs old";

                if ($inj==1) {$notableText.="+";}
            }
            if ($pCnt>3) {$notableText.="\n+ [".($pCnt-3)." more players]($StatsLabPath/tradeBlock.php?team_id=$team_no)";}
        }
        
        // Find color for bar
        $tBright = color_brightness($teams[$team_no]['text_color_id']);
        $bBright = color_brightness($teams[$team_no]['background_color_id']);
        if ( ($tBright > $bBright) || ($bBright > 200) ) {
            if ($tBright > 200) {$barColor=$teams[$team_no]['background_color_id'];}
            else {$barColor = $teams[$team_no]['text_color_id'];}
        }
        else {
            $barColor = $teams[$team_no]['background_color_id'];
        }

        $dataArray = Array (
              "username"   => 'StatsLab',
              "timestamp" => $dcTimestamp,
              "embeds" => Array(
                                Array(
                                      "title" => "StatsLab Trade Block Updated ".$date->format("M j, Y"),
                                      "type" => "rich",
                                      "color" => hexdec(trim($barColor,'#')),
                                      "url" => $StatsLabPath."/tradeBlock.php?team_id=$team_no",
                                      "description" => $msg,
                                      "thumbnail" => [
                                        "url" => $HTMLPath."/images/team_logos/".$teams[$team_no]['logo_file_name']
                                      ],
                                      "fields" => Array(
                                                        Array(
                                                              "name" => "Needs",
                                                              "value" => $needs_text,
                                                              "inline" => "true"
                                                              ),
                                                        Array(
                                                              "name" => "Notable Players",
                                                              "value" => $notableText,
                                                              "inline" => "false"
                                                              )
                                                        )
                                      )
                               )
        );

        $json_data = json_encode($dataArray);

        if (($debug!=1)&&($_GET['showq']!=1))
        {
          $ch = curl_init($serviceURL);

          curl_setopt( $ch, CURLOPT_HTTPHEADER, array('Content-type: application/json'));
          curl_setopt( $ch, CURLOPT_POST, 1);
          curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
          curl_setopt($ch, CURLOPT_POSTFIELDS, $json_data);
          curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
          curl_setopt($ch, CURLOPT_FOLLOWLOCATION, TRUE);

          curl_exec($ch);

          $retcode = curl_getinfo($ch, CURLINFO_HTTP_CODE); // $retcode > 400 -> not found, $retcode = 200, found.

          if (($retcode==200)||($retcode==204))
          {
              1;
              // header('Location: '.$_SERVER['HTTP_REFERER']);
          }
          else
          {
              echo "Discord return code: $retcode</br>";
              echo "Curl error: ".curl_error($ch);
              echo "<br>\n";
              echo $json_data;
          }

          curl_close($ch);
        }
        else
        {
            echo "<b>Discord Test:</b><br/>\n";
            echo "Service URL: $serviceURL<br/>\n";
            echo "<br/>\n";
            echo $data;
            echo "<br/>\n";
            echo "<br/>\n";
        }
    }

    mysqli_close($db);


if($error_count > 0)

{

    ##

    ## An error occurred

    ##

    echo "<h3>An error occurred while trying to update the forum. Contact <a href='http://pebabaseball.com/boards/ucp.php?i=pm&mode=compose&u=31'>Dan DiVincenzo</a> of the Arlington Bureaucrats with the following information:</h3>\n";

    echo "<p>$debug_string</p>\n";

}

else

{

    ##

    ## No errors! Write out 'success' message

    ##

    echo "<h3>Notifications sent successfully for the ".$teams[$team_no]['name'].".</h3>\n";

    echo "   <h3><a href='./tradeBlockAdmin.php'> Back to Front Office Admin Page </a></h3>\n";

}



  ################## END OF PAGE #########################

  echo " </div>   <!-- END contentpane DIV -->\n";

  page_foot($_SESSION['lgpath']);



?>
